/*	
 *	aruru.c - ADf
 *
 *	Copyright (C) 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *
 *	* Sun May 26 22:13:00 JST 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *	- 쐬JnB
 */
#include <piece.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BLOCKSIZE	4096		/* ZN^TCY   */
#define PGD_FNAME	"aruru.pgd"	/* 摜t@C */

typedef struct _PTN {			/* p^[`   */
	unsigned char dx, dy;
	unsigned char sx, sy;
	unsigned char  w,  h;
} PTN;
PTN ptn[] = {
	{ 37, 0,  0,  0, 35, 87 },
	{ 32, 0, 35,  0, 46, 75 },
	{ 23, 0, 81,  0, 77, 79 },
	{ 10, 0,  0, 87, 90, 73 },
	{ 17, 0, 90, 87, 75, 84 },
};
#define N_PTN (sizeof ptn / sizeof *ptn)

unsigned char vbuff[DISP_X * DISP_Y];	/* z  */
char* err;	/* G[bZ[W(NULL:G[Ȃ) */
char* pgd;	/* 摜t@Cǂݍݗpobt@    */
PIECE_BMP bmp;	/* 摜f[^`p\            */
int i_ptn;	/* ݂̕\p^[CfbNX    */

void
pceAppInit()
{
	int retval, i;
	FILEACC fa;
	PBMP_FILEHEADER* bh;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(150);
	pceLCDDispStart();

	/* 摜t@CJ܂B */
	retval = pceFileOpen(&fa, PGD_FNAME, FOMD_RD);
	if(retval != 0) {
		err = "摜̧قJ܂";
		return;
	}

	/* 摜t@Cǂݍݗpobt@mۂ܂B */
	pgd = pceHeapAlloc(fa.fsize);
	if(pgd == NULL) {
		err = "摜̧ٓǍؕs";
		return;
	}

	/* 摜t@Cǂݍ݂܂B */
	for(i = 0; i < fa.fsize; i += BLOCKSIZE) {
		pceFileReadSct(&fa, pgd + i, i / BLOCKSIZE, BLOCKSIZE);
	}

	/* 摜t@C܂B */
	pceFileClose(&fa);

	/* 摜f[^̃ZbgAbvB */
	bh = (PBMP_FILEHEADER*)pgd;
	bmp.header = *bh;
	bmp.buf  = (unsigned char*)(bh + 1);
	bmp.mask = (unsigned char*)(bh + 1) + bh->w * bh->h / (8 / bh->bpp);
}

void
pceAppProc(int count)
{
	PTN* p;
	DRAW_OBJECT obj;

	/* {^ꂽAI܂B */
	if(pcePadGet() & 0xFF00/*TRG_ALL*/) { pceAppReqExit(0); return; }

	if(err != NULL) {
		/* G[ĂAG[bZ[W\܂B */
		memset(vbuff, 3, sizeof vbuff);
		pceFontSetType(0x80);
		pceFontSetTxColor(0);
		pceFontSetBkColor(-1);
		pceFontSetPos((DISP_X - strlen(err) * 5) / 2, (DISP_Y - 10) / 2);
		pceFontPutStr(err);
	} else {
		/* Aj[V\B */
		memset(vbuff, 0, sizeof vbuff);
		p = &ptn[i_ptn];
		pceLCDSetObject(&obj, &bmp, p->dx, p->dy, p->sx, p->sy, p->w, p->h, DRW_NOMAL);
		pceLCDDrawObject(obj);
		pceLCDTrans();
		i_ptn = (i_ptn + 1) % N_PTN;
	}

	/* ʓ]B */
	pceLCDTrans();
}

void
pceAppExit()
{
	/* 摜t@Cǂݍݗpobt@J܂B */
	if(pgd != NULL) pceHeapFree(pgd);
}
